<?php

namespace App\Models\NewsModels;

use App\Models\Traits\Timestamp;
use Illuminate\Database\Eloquent\Model;

class News extends Model
{
    use Timestamp;
    /**
     * 表名。
     *
     * @var string
     */
    protected $table = 'news';

    /**
     * 与表关联的主键。
     *
     * @var string
     */
    protected $primaryKey = 'id';

    /**
     * 是否主动维护时间戳
     *
     * @var bool
     */
    public $timestamps = true;

    /**
     * 不能被批量赋值的属性
     *
     * @var array
     */
    protected $guarded = ['id', 'updated_at', 'created_at'];

}
